"use strict";
var noice_image_picker_common_1 = require("./noice-image-picker.common");
var frame = require("ui/frame");
var imageSource = require('image-source');
var _imagePickerController = null;
var _imagePickerDelegateImpl = null;
var NoiceImagePicker = (function (_super) {
    __extends(NoiceImagePicker, _super);
    function NoiceImagePicker() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NoiceImagePicker.prototype.showPicker = function (args) {
        if (args === void 0) { args = { imageLimit: 5, doneButtonTitle: 'Done' }; }
        return new Promise(function (resolve, reject) {
            _imagePickerController = ImagePickerController.new();
            var imageLimit = args.imageLimit;
            var doneButtonTitle = args.doneButtonTitle;
            _imagePickerController.imageLimit = imageLimit;
            _imagePickerController.doneButtonTitle = doneButtonTitle;
            var vc = null;
            _imagePickerController.delegate = _imagePickerDelegateImpl = ImagePickerDelegateImpl.new().initWithCallback(function (images) {
                var imagesArray = [];
                vc.dismissViewControllerAnimatedCompletion(true, null);
                if (images.count) {
                    images.enumerateObjectsUsingBlock(function (item, index, boolRef) {
                        var imgSrc = new imageSource.ImageSource();
                        imgSrc.setNativeSource(item);
                        imagesArray.push(imgSrc);
                    });
                }
                resolve(imagesArray);
            });
            var topMostFrame = frame.topmost();
            if (topMostFrame) {
                vc = topMostFrame.currentPage && topMostFrame.currentPage.ios;
                if (vc) {
                    vc.presentViewControllerAnimatedCompletion(_imagePickerController, true, null);
                }
            }
        });
    };
    return NoiceImagePicker;
}(noice_image_picker_common_1.Common));
exports.NoiceImagePicker = NoiceImagePicker;
var ImagePickerDelegateImpl = (function (_super) {
    __extends(ImagePickerDelegateImpl, _super);
    function ImagePickerDelegateImpl() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ImagePickerDelegateImpl.new = function () {
        return _super.new.call(this);
    };
    ImagePickerDelegateImpl.prototype.initWithCallback = function (callback) {
        this._callback = callback;
        return this;
    };
    ImagePickerDelegateImpl.prototype.cancelButtonDidPress = function (imagePicker) {
        this._callback();
    };
    ImagePickerDelegateImpl.prototype.doneButtonDidPressImages = function (imagePicker, images) {
        this._callback(images);
    };
    ImagePickerDelegateImpl.prototype.wrapperDidPressImages = function (imagePicker, images) {
        this._callback(images);
    };
    return ImagePickerDelegateImpl;
}(NSObject));
ImagePickerDelegateImpl.ObjCProtocols = [ImagePickerDelegate];
//# sourceMappingURL=noice-image-picker.ios.js.map